/*
 * Options.h
 *
 *      Author: Trax
 */

#ifndef OPTIONS_H_
#define OPTIONS_H_

typedef struct
{
	uint8_t	Input;
	uint16_t InValue;

	uint16_t Aux;

	uint8_t	Output;
	uint16_t OutValue;
} tOption;


#define LO		0
#define HI		1
#define LO_S	2
#define HI_S	3

#define AND		2
#define NOT_AND	3
#define AND_NOT	4
#define NOR		5
#define OR		6
#define NOT_OR	7
#define OR_NOT	8
#define NAND	9
#define XOR		10
#define XNOR	11

#define EQ_VAL 	0
#define GT_VAL 	1
#define LT_VAL 	2
#define NE_VAL 	3
#define EQ_CHN 	4
#define GT_CHN 	5
#define LT_CHN 	6
#define NE_CHN 	7

uint8_t GetOptCount();

uint8_t GetOptIn(uint8_t i);
void SetOptIn(uint8_t i, uint16_t Val);
uint16_t GetOptInVal(uint8_t i);
void SetOptInVal(uint8_t i, uint16_t Val);
uint16_t GetOptAux(uint8_t i);
void SetOptAux(uint8_t i, uint16_t Val);
uint8_t GetOptOut(uint8_t i);
void SetOptOut(uint8_t i, uint16_t Val);
uint16_t GetOptOutVal(uint8_t i);
void SetOptOutVal(uint8_t i, uint16_t Val);

void AddOption(uint8_t* Opt);
void UpOption(uint8_t i);
void RemoveOption(uint8_t i);
void DownOption(uint8_t i);

void MgmtDo();

#endif /* OPTIONS_H_ */
